/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  5 Oct 2011 1:24:58pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "udpCom.h"
#include "tcpCom.h"
#include "serialCom.h"
//[/Headers]

#include "editor.h"
#include "MsgEditor.h"
#include "monitor.h"
#include "manager.h"
#include "sequencer.h"
#include "configuration.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...

//[/MiscUserDefs]

//==============================================================================
editor::editor ()
    : tabbedComponent (0),
      logo (0)
{
    addAndMakeVisible (tabbedComponent = new simtabs (TabbedButtonBar::TabsAtTop));
    tabbedComponent->setTabBarDepth (30);
    tabbedComponent->addTab (T("Message Editor"), Colours::lightgrey, new MsgEditor(), true);
    tabbedComponent->addTab (T("Message Monitor"), Colours::lightgrey, new monitor(), true);
    tabbedComponent->addTab (T("Message Manager"), Colours::lightgrey, new manager(), true);
    tabbedComponent->addTab (T("Sequencer"), Colours::lightgrey, new sequencer(), true);
    tabbedComponent->addTab (T("Configuration"), Colours::lightgrey, new configuration(), true);
    tabbedComponent->setCurrentTabIndex (0);

    addAndMakeVisible (logo = new ImageButton (T("logo")));
    logo->setButtonText (T("new button"));
    logo->addListener (this);

    logo->setImages (false, true, true,
                     ImageCache::getFromMemory (icoindra_png, icoindra_pngSize), 1.0000f, Colour (0x0),
                     ImageCache::getFromMemory (icoindra_png, icoindra_pngSize), 1.0000f, Colour (0x0),
                     ImageCache::getFromMemory (icoindra_png, icoindra_pngSize), 1.0000f, Colour (0x0));

    //[UserPreSize]
    //[/UserPreSize]

    setSize (650, 400);

    //[Constructor] You can add your own custom stuff here..
    setName("MainEditor");


    // Damos de alta el interface de comunicaciones para UDP.
    udpCom* newInterface_UDP = new udpCom();
    newInterface_UDP->initialize();

    // Damos de alta el interface de comunicacion para TCP.
    tcpCom* newInterface_TCP = new tcpCom();
    newInterface_TCP->initialize();

	// Damos de alta el interface de comunicacion para RS232
	serialCom* newInterface_RS232 = new serialCom();
	newInterface_RS232->initialize();

    // Pasamos el puntero del MessageMonitor a la clase de comunicaciones para que pueda visualizar mensajes.
    StringArray tabNames = tabbedComponent->getTabNames();
    for (int i=0;i<tabNames.size();i++){
    	if (tabNames[i]==T("Message Monitor")){
    		//AlertWindow::showNativeDialogBox("ENCONTRADO","Message Monitor",false);
    		(comunications::getRef())->setMonitorRef(tabbedComponent->getTabContentComponent(i));
    	}
    }

    //TODO *** ELIMINAR DESPUES DE LA PRIMERA ENTREGA***
    //Deshabilitamos pestaa "Sequencer".
    tabbedComponent->getTabbedButtonBar().getTabButton(3)->setEnabled(false);


    //[/Constructor]
}

editor::~editor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    deleteAndZero (tabbedComponent);
    deleteAndZero (logo);

    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void editor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void editor::resized()
{
    tabbedComponent->setBounds (0, 0, proportionOfWidth (1.0000f), proportionOfHeight (1.0000f));
    logo->setBounds (584, 0, 64, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void editor::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == logo)
    {
        //[UserButtonCode_logo] -- add your button handler code here..
    	AlertWindow::showMessageBox(AlertWindow::InfoIcon,"Message Studio!","Csar Carlos Ortiz Pantoja.\nccortiz@indra.es\nTorrejn de Ardoz 2011\n\nCompilation: " + String(__DATE__) + ", " + String(__TIME__), "Continue",this);

//    	URL* myURL=new URL("http://www.indracompany.com");
//    	myURL->launchInDefaultBrowser();
        //[/UserButtonCode_logo]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
simtabs::simtabs(TabbedButtonBar::Orientation newOrientation)
:TabbedComponent(newOrientation)
{

}

simtabs::~simtabs(){

}

void simtabs::currentTabChanged(int newCurrentTabIndex, const String& newCurrentTabName) {
	//This make an update of MsgEditor tab with new data.
	static bool firstTime = true;

	if (newCurrentTabName == "Message Editor" && !firstTime) {
		Component* selectedTab = getTabContentComponent(newCurrentTabIndex);

		selectedTab->postCommandMessage(_updateHexEditor_);
		selectedTab->postCommandMessage(_updateFieldEditor_);
	}

	firstTime = false;
}

void editor::handleCommandMessage(int CommandId) {

//	AlertWindow::showMessageBox(
//		AlertWindow::WarningIcon,
//		"Class \"" + getName() + "\"!",
//		"Message Code:" + String(CommandId)
//	);

	switch (CommandId) {
	//Al cargar mensajes desde el Manager, hay que actualizar los datos del editor hexadecimal para evitar que se sobreescriban los datos del editor de mensajes con datos antiguos al cambiar de pestaa.
	case _updateMsgEditor_:
		 tabbedComponent->getTabContentComponent(0)->postCommandMessage(_updateHexEditor_);
		break;

	default:
		// Unknow message!
		AlertWindow::showMessageBox(
			AlertWindow::WarningIcon,
			"Class \"" + getName() + "\"!",
			"Unknow message. Code:" + String(CommandId)
		);
		break;
	}
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="editor" componentName=""
                 parentClasses="public Component" constructorParams="" variableInitialisers=""
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330000013"
                 fixedSize="1" initialWidth="650" initialHeight="400">
  <BACKGROUND backgroundColour="ffffffff"/>
  <TABBEDCOMPONENT name="new tabbed component" id="bb631c0220b4c67e" memberName="tabbedComponent"
                   virtualName="" explicitFocusOrder="0" pos="0 0 100% 100%" orientation="top"
                   tabBarDepth="30" initialTab="0">
    <TAB name="Message Editor" colour="ffd3d3d3" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="MsgEditor.cpp"/>
    <TAB name="Message Monitor" colour="ffd3d3d3" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="monitor.cpp"/>
    <TAB name="Message Manager" colour="ffd3d3d3" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="manager.cpp"/>
    <TAB name="Sequencer" colour="ffd3d3d3" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="sequencer.cpp"/>
    <TAB name="Configuration" colour="ffd3d3d3" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="configuration.cpp"/>
  </TABBEDCOMPONENT>
  <IMAGEBUTTON name="logo" id="eab2cc34bd7f41ab" memberName="logo" virtualName=""
               explicitFocusOrder="0" pos="584 0 64 24" buttonText="new button"
               connectedEdges="0" needsCallback="1" radioGroupId="0" keepProportions="1"
               resourceNormal="icoindra_png" opacityNormal="1" colourNormal="0"
               resourceOver="icoindra_png" opacityOver="1" colourOver="0" resourceDown="icoindra_png"
               opacityDown="1" colourDown="0"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: icoindra_png, 2232, "../../../../../Recursos/ICONOS/FAVORITOS/PNG/ico-indra.png"
static const unsigned char resource_editor_icoindra_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,0,70,0,0,0,26,8,6,0,0,0,10,98,42,8,0,0,0,3,115,66,73,84,8,8,8,219,225,79,224,0,0,0,1,115,
82,71,66,0,174,206,28,233,0,0,0,4,103,65,77,65,0,0,177,143,11,252,97,5,0,0,0,9,112,72,89,115,0,0,11,17,0,0,11,17,1,127,100,95,145,0,0,0,31,116,69,88,116,83,111,102,116,119,97,114,101,0,77,97,99,114,111,
109,101,100,105,97,32,70,105,114,101,119,111,114,107,115,32,56,181,104,210,120,0,0,0,22,116,69,88,116,67,114,101,97,116,105,111,110,32,84,105,109,101,0,48,53,47,48,52,47,48,57,186,91,231,52,0,0,7,241,
73,68,65,84,88,71,237,89,73,76,84,107,26,61,64,81,85,140,197,160,50,8,8,168,40,82,20,239,33,243,3,95,211,113,218,153,152,104,226,180,48,113,54,81,23,110,77,122,225,194,232,194,196,133,99,116,165,187,78,
71,23,174,108,58,157,126,10,15,121,50,63,68,64,102,68,230,98,158,185,125,190,207,174,106,160,235,181,116,98,155,72,222,79,110,234,222,170,127,60,255,57,231,251,254,139,151,193,130,223,203,127,32,224,253,
59,38,158,17,88,17,48,83,83,83,152,153,153,209,30,102,103,231,208,219,215,135,145,145,145,85,141,233,103,129,25,25,25,69,233,235,50,212,212,214,42,40,125,4,165,184,248,103,212,212,212,98,97,97,1,19,19,
19,24,28,28,228,253,252,170,2,202,35,48,178,224,206,206,46,180,183,119,64,216,50,74,112,38,39,167,225,237,5,248,249,89,17,98,179,33,44,44,12,243,115,115,4,236,87,148,252,252,26,253,253,131,171,10,24,47,
79,230,59,49,49,137,159,94,189,162,124,102,241,67,110,14,124,136,72,95,255,0,172,86,43,34,34,214,97,126,126,129,215,28,25,52,139,166,166,247,100,204,16,210,183,127,15,127,127,127,5,43,48,48,16,94,94,68,
241,27,46,75,128,145,0,53,62,62,161,139,238,234,250,160,210,73,177,111,195,194,252,60,94,21,151,96,120,120,4,127,44,252,17,193,193,193,248,233,101,177,2,147,230,72,69,72,136,77,61,168,236,151,114,50,107,
2,185,4,51,56,40,232,171,193,50,57,57,169,227,203,198,89,44,150,47,50,238,18,41,137,161,138,127,84,85,215,32,146,204,88,48,22,148,17,178,251,209,209,81,136,141,141,209,251,209,209,81,24,148,155,183,183,
55,204,102,51,129,19,6,205,195,215,100,130,197,108,129,201,199,244,69,38,183,146,78,100,51,111,222,188,137,3,7,14,224,222,189,123,43,105,178,162,58,75,128,145,69,250,249,19,117,126,78,115,7,62,118,247,
160,251,67,55,35,208,40,66,67,66,145,156,188,21,173,173,109,40,43,123,131,77,155,54,34,47,39,75,217,245,143,151,175,208,220,220,10,135,195,142,239,190,115,160,183,183,23,67,148,215,215,40,178,81,37,37,
37,120,241,226,5,74,75,75,191,216,144,238,173,21,89,140,142,141,99,235,150,36,149,138,236,132,221,158,76,70,88,184,232,22,116,208,140,211,210,82,49,53,61,69,185,141,195,68,118,44,176,142,208,120,132,12,
10,162,175,4,4,4,80,130,93,26,197,98,98,98,144,151,155,253,155,94,35,139,121,250,244,41,182,109,219,134,253,251,247,115,140,102,60,127,254,28,115,244,40,89,172,43,239,140,142,142,198,238,221,187,17,23,
23,167,139,30,30,30,86,16,154,154,154,84,202,82,79,218,74,145,241,165,200,156,138,138,138,80,89,89,169,145,115,231,206,157,200,203,203,195,192,192,128,182,109,105,105,209,182,50,142,92,34,195,130,130,
2,236,218,181,235,223,192,138,249,74,233,232,232,52,254,252,151,103,70,101,101,181,49,54,54,102,148,150,150,25,229,21,149,6,27,25,45,45,173,6,37,102,244,247,15,24,99,227,227,198,192,224,160,209,216,216,
100,188,248,107,145,81,255,238,157,126,223,221,221,99,48,146,241,234,52,222,148,87,24,140,104,174,174,61,126,94,189,122,85,50,110,35,43,43,139,99,119,24,247,239,223,215,103,79,215,190,125,251,12,167,211,
169,243,186,116,233,146,65,115,247,88,239,236,217,179,58,214,173,91,183,12,70,77,119,157,107,215,174,25,76,41,12,249,157,62,228,177,237,185,115,231,150,204,211,45,37,43,195,112,88,168,77,13,76,118,109,
152,126,195,5,171,119,172,91,183,150,44,10,210,251,0,70,158,176,208,80,69,86,36,70,204,17,30,30,6,167,115,8,197,37,165,152,100,120,223,152,152,8,31,50,106,122,250,83,82,232,169,8,227,164,136,89,138,87,
249,248,248,232,115,40,251,190,114,229,10,30,60,120,128,35,71,142,232,111,207,158,61,83,86,16,64,16,64,16,32,28,58,116,8,119,239,222,85,127,113,56,28,218,86,172,64,230,46,204,147,220,42,51,51,19,55,110,
220,192,193,131,7,81,203,60,236,225,195,135,154,126,28,63,126,92,251,185,126,253,58,237,33,89,219,250,250,250,46,153,166,27,24,27,229,227,72,181,99,195,134,88,13,183,142,212,20,100,101,110,87,160,36,28,
191,173,111,64,91,123,59,154,73,195,55,111,42,16,108,11,70,225,31,118,232,100,200,40,46,204,91,67,185,213,234,135,134,198,70,188,46,251,5,31,63,126,252,77,96,92,225,92,22,46,247,242,41,37,60,60,28,103,
206,156,193,137,19,39,192,29,166,233,71,235,247,98,248,67,67,67,154,80,138,76,207,159,63,143,211,167,79,131,12,114,47,78,250,17,137,200,37,133,76,195,229,203,151,145,144,144,128,158,158,30,149,76,124,
124,60,46,94,188,136,147,39,79,226,194,133,11,216,188,121,179,214,117,141,239,154,176,27,152,54,38,115,37,165,175,117,87,26,26,26,241,142,151,228,49,61,61,189,234,33,137,9,241,136,138,140,4,101,132,214,
182,54,13,229,193,193,54,180,241,158,242,99,200,14,65,65,126,30,98,214,71,235,174,75,84,11,8,252,164,249,255,165,136,103,184,142,31,194,42,23,147,22,251,142,244,231,98,156,220,47,206,153,22,131,188,184,
206,226,179,178,171,207,197,191,47,159,163,2,99,240,207,155,104,251,154,124,97,34,165,166,167,167,65,47,209,29,170,172,170,230,226,59,144,148,180,137,59,181,158,0,37,40,179,198,105,212,93,31,62,32,146,
96,37,38,198,115,162,190,106,132,98,118,161,204,107,146,183,110,193,26,238,254,231,138,107,194,174,79,145,171,200,65,138,236,188,60,235,28,217,183,128,47,210,163,143,169,20,30,63,126,172,146,107,104,104,
112,215,113,213,117,181,119,245,43,153,186,0,209,78,214,223,185,115,7,79,158,60,209,240,238,50,110,153,247,226,162,192,136,79,108,136,139,69,118,102,134,14,190,113,99,2,178,50,182,43,16,81,81,145,42,47,
41,111,235,235,233,59,253,74,119,153,76,93,93,157,134,109,161,106,117,117,173,50,77,14,152,37,244,154,234,154,95,221,59,239,9,28,23,221,69,26,50,169,229,207,210,70,64,145,223,165,136,175,136,132,196,31,
68,190,143,30,61,194,177,99,199,112,234,212,41,148,151,151,107,29,217,80,233,75,124,100,57,48,118,187,29,135,15,31,86,201,220,190,125,27,71,143,30,85,57,138,247,184,218,46,158,167,207,159,88,20,28,50,
166,139,33,185,188,162,74,207,65,145,145,17,26,166,103,104,160,91,146,54,243,119,111,84,50,241,235,237,237,67,44,1,147,244,223,102,11,161,108,66,212,232,154,104,142,126,126,126,148,80,4,253,96,12,129,
254,126,136,96,31,203,181,187,120,112,27,207,92,123,246,236,65,70,70,134,122,153,60,75,104,150,208,42,253,203,156,130,152,65,167,167,167,163,176,176,80,129,201,205,205,85,79,73,73,73,65,78,78,14,242,243,
243,53,212,202,189,180,77,74,74,210,49,101,179,246,238,221,171,159,210,143,248,166,212,145,182,169,169,169,238,182,59,118,236,64,118,118,182,206,67,218,186,138,251,72,32,148,171,123,91,143,247,239,155,
145,185,61,29,81,204,116,139,254,246,119,205,89,178,179,50,117,151,36,15,144,197,175,93,183,6,102,95,51,243,158,49,84,209,95,44,86,11,214,211,91,102,233,73,115,164,127,248,154,112,230,20,254,116,122,179,
39,178,124,19,223,45,57,43,9,157,167,72,71,231,144,147,30,51,70,16,252,97,181,124,10,129,149,85,53,76,178,98,144,194,132,76,232,39,161,56,42,42,138,146,169,197,26,2,33,224,85,144,109,13,76,188,114,178,
51,41,205,79,9,217,183,90,150,28,9,36,150,203,78,75,132,170,169,169,35,43,124,213,92,133,230,98,204,194,18,57,2,56,135,71,49,72,240,132,230,185,204,110,37,143,233,163,247,72,52,146,232,245,53,15,144,255,
47,224,61,190,118,16,96,70,152,122,71,208,47,58,153,226,91,45,86,26,112,156,106,215,100,242,209,19,184,132,240,181,100,202,60,205,238,37,79,218,98,148,5,249,63,104,34,184,26,138,199,23,85,18,161,82,25,
146,5,8,73,222,250,250,250,49,51,59,163,178,145,203,76,121,201,107,9,137,62,19,244,32,97,149,24,173,217,188,52,123,252,150,1,250,175,175,54,109,204,110,51,25,182,83,82,146,245,213,165,0,228,116,14,51,
82,77,255,107,205,134,202,44,45,205,142,239,211,28,122,191,90,138,71,41,121,90,156,72,101,144,9,159,100,141,161,204,117,228,4,43,96,5,6,174,14,233,44,95,243,138,129,89,45,76,88,233,58,62,251,95,130,149,
118,180,218,234,253,19,170,198,84,1,245,120,248,115,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* editor::icoindra_png = (const char*) resource_editor_icoindra_png;
const int editor::icoindra_pngSize = 2232;
