/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  9 Aug 2011 9:04:44am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

#ifndef __JUCER_HEADER_HEXEDITOR_HEXEDITOR_9AE92ED6__
#define __JUCER_HEADER_HEXEDITOR_HEXEDITOR_9AE92ED6__

//[Headers]     -- You can add your own extra header files here --
#include "juce.h"
#include "../config.h"

#define _updateFieldEditor_ 2

class byteEditor : public TextEditor{

public:
	byteEditor(){
	}

private:
	void focusGained( FocusChangeType  cause ){
		setCaretPosition(getTotalNumChars());
		Range<int> newSelection(0,getCaretPosition());
		setHighlightedRegion(newSelection);
		repaint();
	}

	void focusLost( FocusChangeType  cause ){
		Range<int> newSelection(0,0);
		setHighlightedRegion(newSelection);
		getParentComponent()->repaint();
		setText(getText().paddedLeft('0',2),false);
		getParentComponent()->getParentComponent()->postCommandMessage(_updateFieldEditor_);
		repaint();
	}

	bool keyPressed(const KeyPress&  key){
		bool retorno=true;

		if (key.isKeyCode(key.backspaceKey)){

			if (getCaretPosition()>0){
				Range< int >   newSelection(getCaretPosition()-1,getCaretPosition());
				setHighlightedRegion(newSelection);
				cut();
			}
		}

		if (key.isKeyCode(key.deleteKey)){
			Range< int >   newSelection(getCaretPosition(),getCaretPosition()+1);
			setHighlightedRegion(newSelection);
			cut();
		}

		if (key.isKeyCode(key.leftKey)){
			setCaretPosition(getCaretPosition()-1);
		}

		if (key.isKeyCode(key.rightKey)){
			setCaretPosition(getCaretPosition()+1);
		}

		if(key.isKeyCode(key.tabKey)){
			retorno=false;
		}

		if (key.isKeyCode(key.returnKey)){
			moveKeyboardFocusToSibling(true);
		}

		if ( (key.getTextCharacter()>='0' && key.getTextCharacter()<='9') ||
			 (CharacterFunctions::toUpperCase(key.getTextCharacter())>='A' && CharacterFunctions::toUpperCase(key.getTextCharacter())<='F')){
			String cadena1;
			String cadena2;

			cadena1 += CharacterFunctions::toUpperCase(key.getTextCharacter());
			cadena2 = getText();

			insertTextAtCaret(cadena1);
			int value = getText().getHexValue32();

			if (value<0 || value>255){
				setText(cadena2,false);
			}

			if (getText().length()==2){
				moveKeyboardFocusToSibling(true);
			}

		}

		return retorno;
	}
};
//[/Headers]



//==============================================================================
/**
                                                                    //[Comments]
    An auto-generated component, created by the Jucer.

    Describe your class and how it works here!
                                                                    //[/Comments]
*/
class hexEditor  : public Component,
                   public ButtonListener
{
public:
    //==============================================================================
    hexEditor ();
    ~hexEditor();

    //==============================================================================
    //[UserMethods]     -- You can add your own custom methods in this section.
    void refreshTable();
    int getDataBuffer(char* dataBuffer);
    int getDataLength();
    void setDataBuffer(char* dataBuffer, unsigned int length, bool backToTop=false);
    void cleanDataBuffer();
    void setEditable(bool state);
    //[/UserMethods]

    void paint (Graphics& g);
    void resized();
    void buttonClicked (Button* buttonThatWasClicked);

    // Binary resources:
    static const char* resultset_first_png;
    static const int resultset_first_pngSize;
    static const char* resultset_last_png;
    static const int resultset_last_pngSize;
    static const char* resultset_next_png;
    static const int resultset_next_pngSize;
    static const char* resultset_previous_png;
    static const int resultset_previous_pngSize;

    //==============================================================================
    juce_UseDebuggingNewOperator

private:
    //[UserVariables]   -- You can add your own custom variables in this section.
    unsigned char dataBuffer[_HEX_BUFFER_LENGTH_];
    byteEditor* dataEditors[_HEX_BUFFER_LENGTH_];
    Label* posLabel[5];
    int filas;
    int columnas;
    int startByte;
    unsigned int dataLenght;
    void updateDataBuffer();
    //[/UserVariables]

    //==============================================================================
    TextButton* startButton;
    TextButton* previousButton;
    TextButton* nextButton;
    TextButton* endButton;

    //==============================================================================
    // (prevent copy constructor and operator= being generated..)
    hexEditor (const hexEditor&);
    const hexEditor& operator= (const hexEditor&);
};


#endif   // __JUCER_HEADER_HEXEDITOR_HEXEDITOR_9AE92ED6__
