/*==============================================================================
  File Name: bitStacker.h
  Author   : ccortiz
  
  Description:
  Class for stack and unstack bits in a byte buffer.
  ==============================================================================
*/

#ifndef BITSTACK_H_
#define BITSTACK_H_

#define _MAX_DATA_STACK_SIZE_ 1024
#define _MAX_BITSTACK_INSTANCES_ 40

#include "dataTypes.h"
#include <string.h>

typedef struct c_bitStack_Privates* bitStack_PrivatesPtr;

struct c_bitStack_Privates{
	byte   dataStack[_MAX_DATA_STACK_SIZE_];
	uint32 stackSize;
	uint32 auxUsedBits;
	enum endianness outputEndianness;

	uint32  unstackIndex;  /* Index of current unstacked byte. */
	uint32  unstackedBit;  /* Bit of unstacked byte currently unstacked. */
	uint32  unstackedByte; /* Byte of dataStack currently unstacked. */
	boolean firstUnstak;
};

int new_bitStack(void);

sint32  stackData(uint16 bitStackDescriptor, unsigned char* data, uint32 dataLength);
uint32  unstackData(uint16 bitStackDescriptor, uint8 nBits);
void    showStack(uint16 bitStackDescriptor);
uint32  getStackSize(uint16 bitStackDescriptor);

void setOutputEndianness(uint16 bitStackDescriptor, enum endianness endianType);
void clearStack(uint16 bitStackDescriptor);
byte_ptr getDataBuffer(uint16 bitStackDescriptor);
sint32 setDataBuffer(uint16 bitStackDescriptor, byte_ptr data,uint16 dataLength);


#endif /* BITSTACK_H_ */
