
/*==============================================================================
  File Name: dataTypes.h
  Author   : ccortiz
  
  Description:
  Data Types for API description.
  ==============================================================================
*/

#ifndef __DATA_TYPES_H__
#define __DATA_TYPES_H__

#define _DEBUG_

#ifdef _DEBUG_
	#include <stdio.h>

	#define _DBGMSG_(yourString) printf(yourString)
#else
	#define _DBGMSG_(yourString) /*Nothing*/
#endif

#define _ALLOW_MALLOC_ 1
#define _TRUE_  1
#define _FALSE_ 0

	enum endianness{_LITTLE_ENDIAN_ , _BIG_ENDIAN_};
	enum deserializeState {_DESERIALIZE_OK_, _INCORRECT_MSG_SIZE_, _INCORRECT_CONSTANT_FIELDS_, _ITEM_OUT_OF_RANGE_, _FIELDS_OUT_OF_RANGE_, _INVALID_DESCRIPTOR_};
	enum status {setterError,setterOK};
	enum msgTypes{_MENSAJE1_, _MENSAJE2_, _MENSAJE3_};
	typedef unsigned char          byte; 
	typedef unsigned char*         byte_ptr; 
	typedef signed   char          sint8; 
	typedef signed   short int     sint16;   
	typedef signed   int           sint32;

	typedef unsigned char          uint8;
	typedef unsigned short int     uint16;
	typedef unsigned int           uint32;

	typedef unsigned char          boolean;

	typedef byte_ptr(*serializerPtr)(int msgDescriptor);
	typedef int(*deserializerPtr)(int ICD_Descriptor, byte_ptr dataBuffer,uint16 bufferSize, boolean decodeMessage);
	typedef void (*setEndiannessPtr)(int, enum endianness);
	typedef int(*getMsgSizePtr)(int msgDescriptor);


#endif

