/*
 * ICD.c
 *
 *  Created on: 25/05/2012
 *      Author: ccortiz
 */

#include "default_ICD.h"

#if  _ALLOW_MALLOC_ == 0
/* Reserve maximum amount of memory allowed for ICDs. */
struct  c_DEFAULT_ICD_Privates ICD_Instances[_MAX_ICD_INSTANCES_];
#else
#include <stdlib.h>
#endif

static int searchMsg(int ICD_Descriptor, byte_ptr buffer, unsigned int length);
static void setICDEndianness(int ICD_Descriptor, enum endianness endianType);

c_DEFAULT_ICD_Privates_Ptr ICD_Objs[_MAX_ICD_INSTANCES_];
unsigned int nObjs=0;

int new_Default_ICD(void){

	static boolean firstInstance = _FALSE_;
	c_DEFAULT_ICD_Privates_Ptr newObj;
	
	if (firstInstance==_FALSE_){
		uint16 i=0;
		firstInstance = _TRUE_;

		for (i=0; i<_MAX_ICD_INSTANCES_; i++){
			ICD_Objs[i] = 0;
		}
	}


	if (nObjs>_MAX_ICD_INSTANCES_ -1){
		/* No more instances allowed. */
		return -1;
	}

	 

#if _ALLOW_MALLOC_==0
	newObj =&ICD_Instances[nObjs];
#else
	newObj = (c_DEFAULT_ICD_Privates_Ptr)malloc(sizeof(struct c_DEFAULT_ICD_Privates));
#endif

	if (newObj==0){
		return -1;
	}
	else{
		/* Registrar en el array de objetos. */
		ICD_Objs[nObjs] = newObj;

		/* Initializers. */
		initialize_Mensaje1(nObjs, &Default_ICD.mensaje1 , &(newObj->mensaje1_Privates) );
		initialize_Mensaje2(nObjs, &Default_ICD.mensaje2 , &(newObj->mensaje2_Privates) );
		initialize_Mensaje3(nObjs, &Default_ICD.mensaje3 , &(newObj->mensaje3_Privates) );

		Default_ICD.setEndianness = setICDEndianness;
		Default_ICD.search        = searchMsg;
	}

	nObjs++;

	return nObjs-1;
}

void setICDEndianness(int ICD_Descriptor, enum endianness endianType){

	Default_ICD.mensaje1.set_Endianness(ICD_Descriptor, endianType);
	Default_ICD.mensaje2.set_Endianness(ICD_Descriptor, endianType);
	Default_ICD.mensaje3.set_Endianness(ICD_Descriptor, endianType);
	
}

int searchMsg(int ICD_Descriptor, byte_ptr buffer, unsigned int length){
	if (Default_ICD.mensaje1.deserialize(ICD_Descriptor, buffer, length, _FALSE_)==_DESERIALIZE_OK_){ return _MENSAJE1_; }
	if (Default_ICD.mensaje2.deserialize(ICD_Descriptor, buffer, length, _FALSE_)==_DESERIALIZE_OK_){ return _MENSAJE2_; }
	if (Default_ICD.mensaje3.deserialize(ICD_Descriptor, buffer, length, _FALSE_)==_DESERIALIZE_OK_){ return _MENSAJE3_; }
	return -1;
}

