/*
 * main.c
 *
 *  Created on: 06/06/2012
 *      Author: ccortiz
 */

#include <stdio.h>
#include "default_ICD.h"

int main(void){

	int i=0;
	int serializedLength=0;
	byte_ptr serializedBuffer=0;
	byte deserializeBuffer[256];
	int msgID=0;

	byte contentBuffer[]={
			0xAA, 0xAA, 0xAA, 0xAA,
			0xAA, 0xAA, 0xAA, 0xAA,
			0xAA, 0xAA, 0xAA, 0xAA,
			0xAA, 0xAA, 0xAA, 0xAA};

	int myICD = new_Default_ICD();
	if (myICD==-1){
		printf ("Error obteniendo descriptor para ICD\n");
		return -1;
	}

	/* -------------- Prueba de serializacion de mensajes -------------*/
	Default_ICD.setEndianness(myICD, _LITTLE_ENDIAN_);

	Default_ICD.mensaje1.set_Repetitions(myICD,4);

	for (i=0; i<Default_ICD.mensaje1.get_Repetitions(myICD); i++){
		Default_ICD.mensaje1.set_BlockSize(myICD, i, i+1);
		Default_ICD.mensaje1.set_Block(myICD, i, contentBuffer);
	}

	serializedBuffer = Default_ICD.mensaje1.serialize(myICD);
	serializedLength = Default_ICD.mensaje1.get_MsgSize(myICD);

	for (i=0; i< serializedLength; i++){
		printf ("%.2X ", (serializedBuffer[i]&0xFF));
	}

	printf("\n");

	/* ------------ Prueba de deserializacion de mensajes ------------*/
	memcpy(deserializeBuffer, serializedBuffer, serializedLength);
	/* deserializeBuffer[0]=0x01; */

	msgID = Default_ICD.search(myICD, deserializeBuffer, serializedLength);
	switch (msgID) {
		case _MENSAJE1_:

			printf("Identificado _MENSAJE1_ !\n");
			Default_ICD.mensaje1.deserialize(myICD, deserializeBuffer, serializedLength, _TRUE_);

			printf ("   > ID: %d\n", Default_ICD.mensaje1.get_ID(myICD));
			printf ("   > Repetitions: %d\n", Default_ICD.mensaje1.get_Repetitions(myICD));

			for (i=0; i<Default_ICD.mensaje1.get_Repetitions(myICD); i++){
				int j=0;
				byte buffer[256];

				printf("   > Block_Size[%d]: %d\n   > ", i, Default_ICD.mensaje1.get_BlockSize(myICD, i));

				Default_ICD.mensaje1.get_Block(myICD, i, buffer);
				for (j=0; j<Default_ICD.mensaje1.get_BlockSize(myICD, i); j++){
					printf ("%.2X ", buffer[j]);
				}
				printf("\n");
			}

			break;

		case _MENSAJE2_:
			printf("Identificado _MENSAJE2_ !\n");
			Default_ICD.mensaje2.deserialize(myICD, deserializeBuffer, serializedLength, _TRUE_);
			break;

		case _MENSAJE3_:
			printf("Identificado _MENSAJE3_ !\n");
			Default_ICD.mensaje3.deserialize(myICD, deserializeBuffer, serializedLength, _TRUE_);
			break;


		default:
			printf("Mensaje no identificado! \n");
			break;
	}

	return 0;
}

