/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package messaging;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see messaging.MessagingFactory
 * @model kind="package"
 * @generated
 */
public interface MessagingPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "messaging";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://messaging/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "messaging";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MessagingPackage eINSTANCE = messaging.impl.MessagingPackageImpl.init();

	/**
	 * The meta object id for the '{@link messaging.impl.MessageImpl <em>Message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.impl.MessageImpl
	 * @see messaging.impl.MessagingPackageImpl#getMessage()
	 * @generated
	 */
	int MESSAGE = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Items</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__ITEMS = 2;

	/**
	 * The number of structural features of the '<em>Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link messaging.impl.dataFieldImpl <em>data Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.impl.dataFieldImpl
	 * @see messaging.impl.MessagingPackageImpl#getdataField()
	 * @generated
	 */
	int DATA_FIELD = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Field Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__FIELD_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__SIZE = 3;

	/**
	 * The feature id for the '<em><b>Generate Accesors</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__GENERATE_ACCESORS = 4;

	/**
	 * The feature id for the '<em><b>Min Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__MIN_VALUE = 5;

	/**
	 * The feature id for the '<em><b>Max Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__MAX_VALUE = 6;

	/**
	 * The feature id for the '<em><b>Include Limits</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__INCLUDE_LIMITS = 7;

	/**
	 * The feature id for the '<em><b>Depends on</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD__DEPENDS_ON = 8;

	/**
	 * The number of structural features of the '<em>data Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FIELD_FEATURE_COUNT = 9;

	/**
	 * The meta object id for the '{@link messaging.impl.dataItemImpl <em>data Item</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.impl.dataItemImpl
	 * @see messaging.impl.MessagingPackageImpl#getdataItem()
	 * @generated
	 */
	int DATA_ITEM = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM__NAME = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Fields</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM__FIELDS = 2;

	/**
	 * The feature id for the '<em><b>Occurrences</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM__OCCURRENCES = 3;

	/**
	 * The feature id for the '<em><b>Depends on</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM__DEPENDS_ON = 4;

	/**
	 * The number of structural features of the '<em>data Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ITEM_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link messaging.impl.ICDImpl <em>ICD</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.impl.ICDImpl
	 * @see messaging.impl.MessagingPackageImpl#getICD()
	 * @generated
	 */
	int ICD = 3;

	/**
	 * The feature id for the '<em><b>Messages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICD__MESSAGES = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICD__NAME = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICD__DESCRIPTION = 2;

	/**
	 * The number of structural features of the '<em>ICD</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICD_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link messaging.dataTypes <em>data Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.dataTypes
	 * @see messaging.impl.MessagingPackageImpl#getdataTypes()
	 * @generated
	 */
	int DATA_TYPES = 4;

	/**
	 * The meta object id for the '{@link messaging.limitsInclusion <em>limits Inclusion</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.limitsInclusion
	 * @see messaging.impl.MessagingPackageImpl#getlimitsInclusion()
	 * @generated
	 */
	int LIMITS_INCLUSION = 5;

	/**
	 * The meta object id for the '{@link messaging.accesorTypes <em>accesor Types</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see messaging.accesorTypes
	 * @see messaging.impl.MessagingPackageImpl#getaccesorTypes()
	 * @generated
	 */
	int ACCESOR_TYPES = 6;


	/**
	 * Returns the meta object for class '{@link messaging.Message <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Message</em>'.
	 * @see messaging.Message
	 * @generated
	 */
	EClass getMessage();

	/**
	 * Returns the meta object for the attribute '{@link messaging.Message#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see messaging.Message#getName()
	 * @see #getMessage()
	 * @generated
	 */
	EAttribute getMessage_Name();

	/**
	 * Returns the meta object for the attribute '{@link messaging.Message#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see messaging.Message#getDescription()
	 * @see #getMessage()
	 * @generated
	 */
	EAttribute getMessage_Description();

	/**
	 * Returns the meta object for the containment reference list '{@link messaging.Message#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Items</em>'.
	 * @see messaging.Message#getItems()
	 * @see #getMessage()
	 * @generated
	 */
	EReference getMessage_Items();

	/**
	 * Returns the meta object for class '{@link messaging.dataField <em>data Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>data Field</em>'.
	 * @see messaging.dataField
	 * @generated
	 */
	EClass getdataField();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see messaging.dataField#getName()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Name();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see messaging.dataField#getDescription()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Description();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getField_Type <em>Field Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Field Type</em>'.
	 * @see messaging.dataField#getField_Type()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Field_Type();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see messaging.dataField#getSize()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Size();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getGenerate_Accesors <em>Generate Accesors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Generate Accesors</em>'.
	 * @see messaging.dataField#getGenerate_Accesors()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Generate_Accesors();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getMinValue <em>Min Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min Value</em>'.
	 * @see messaging.dataField#getMinValue()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_MinValue();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getMaxValue <em>Max Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Value</em>'.
	 * @see messaging.dataField#getMaxValue()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_MaxValue();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getInclude_Limits <em>Include Limits</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Include Limits</em>'.
	 * @see messaging.dataField#getInclude_Limits()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Include_Limits();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataField#getDepends_on <em>Depends on</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Depends on</em>'.
	 * @see messaging.dataField#getDepends_on()
	 * @see #getdataField()
	 * @generated
	 */
	EAttribute getdataField_Depends_on();

	/**
	 * Returns the meta object for class '{@link messaging.dataItem <em>data Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>data Item</em>'.
	 * @see messaging.dataItem
	 * @generated
	 */
	EClass getdataItem();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataItem#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see messaging.dataItem#getName()
	 * @see #getdataItem()
	 * @generated
	 */
	EAttribute getdataItem_Name();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataItem#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see messaging.dataItem#getDescription()
	 * @see #getdataItem()
	 * @generated
	 */
	EAttribute getdataItem_Description();

	/**
	 * Returns the meta object for the containment reference list '{@link messaging.dataItem#getFields <em>Fields</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fields</em>'.
	 * @see messaging.dataItem#getFields()
	 * @see #getdataItem()
	 * @generated
	 */
	EReference getdataItem_Fields();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataItem#getOccurrences <em>Occurrences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Occurrences</em>'.
	 * @see messaging.dataItem#getOccurrences()
	 * @see #getdataItem()
	 * @generated
	 */
	EAttribute getdataItem_Occurrences();

	/**
	 * Returns the meta object for the attribute '{@link messaging.dataItem#getDepends_on <em>Depends on</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Depends on</em>'.
	 * @see messaging.dataItem#getDepends_on()
	 * @see #getdataItem()
	 * @generated
	 */
	EAttribute getdataItem_Depends_on();

	/**
	 * Returns the meta object for class '{@link messaging.ICD <em>ICD</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ICD</em>'.
	 * @see messaging.ICD
	 * @generated
	 */
	EClass getICD();

	/**
	 * Returns the meta object for the containment reference list '{@link messaging.ICD#getMessages <em>Messages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Messages</em>'.
	 * @see messaging.ICD#getMessages()
	 * @see #getICD()
	 * @generated
	 */
	EReference getICD_Messages();

	/**
	 * Returns the meta object for the attribute '{@link messaging.ICD#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see messaging.ICD#getName()
	 * @see #getICD()
	 * @generated
	 */
	EAttribute getICD_Name();

	/**
	 * Returns the meta object for the attribute '{@link messaging.ICD#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see messaging.ICD#getDescription()
	 * @see #getICD()
	 * @generated
	 */
	EAttribute getICD_Description();

	/**
	 * Returns the meta object for enum '{@link messaging.dataTypes <em>data Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>data Types</em>'.
	 * @see messaging.dataTypes
	 * @generated
	 */
	EEnum getdataTypes();

	/**
	 * Returns the meta object for enum '{@link messaging.limitsInclusion <em>limits Inclusion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>limits Inclusion</em>'.
	 * @see messaging.limitsInclusion
	 * @generated
	 */
	EEnum getlimitsInclusion();

	/**
	 * Returns the meta object for enum '{@link messaging.accesorTypes <em>accesor Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>accesor Types</em>'.
	 * @see messaging.accesorTypes
	 * @generated
	 */
	EEnum getaccesorTypes();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MessagingFactory getMessagingFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link messaging.impl.MessageImpl <em>Message</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.impl.MessageImpl
		 * @see messaging.impl.MessagingPackageImpl#getMessage()
		 * @generated
		 */
		EClass MESSAGE = eINSTANCE.getMessage();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__NAME = eINSTANCE.getMessage_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__DESCRIPTION = eINSTANCE.getMessage_Description();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MESSAGE__ITEMS = eINSTANCE.getMessage_Items();

		/**
		 * The meta object literal for the '{@link messaging.impl.dataFieldImpl <em>data Field</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.impl.dataFieldImpl
		 * @see messaging.impl.MessagingPackageImpl#getdataField()
		 * @generated
		 */
		EClass DATA_FIELD = eINSTANCE.getdataField();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__NAME = eINSTANCE.getdataField_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__DESCRIPTION = eINSTANCE.getdataField_Description();

		/**
		 * The meta object literal for the '<em><b>Field Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__FIELD_TYPE = eINSTANCE.getdataField_Field_Type();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__SIZE = eINSTANCE.getdataField_Size();

		/**
		 * The meta object literal for the '<em><b>Generate Accesors</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__GENERATE_ACCESORS = eINSTANCE.getdataField_Generate_Accesors();

		/**
		 * The meta object literal for the '<em><b>Min Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__MIN_VALUE = eINSTANCE.getdataField_MinValue();

		/**
		 * The meta object literal for the '<em><b>Max Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__MAX_VALUE = eINSTANCE.getdataField_MaxValue();

		/**
		 * The meta object literal for the '<em><b>Include Limits</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__INCLUDE_LIMITS = eINSTANCE.getdataField_Include_Limits();

		/**
		 * The meta object literal for the '<em><b>Depends on</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_FIELD__DEPENDS_ON = eINSTANCE.getdataField_Depends_on();

		/**
		 * The meta object literal for the '{@link messaging.impl.dataItemImpl <em>data Item</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.impl.dataItemImpl
		 * @see messaging.impl.MessagingPackageImpl#getdataItem()
		 * @generated
		 */
		EClass DATA_ITEM = eINSTANCE.getdataItem();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ITEM__NAME = eINSTANCE.getdataItem_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ITEM__DESCRIPTION = eINSTANCE.getdataItem_Description();

		/**
		 * The meta object literal for the '<em><b>Fields</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_ITEM__FIELDS = eINSTANCE.getdataItem_Fields();

		/**
		 * The meta object literal for the '<em><b>Occurrences</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ITEM__OCCURRENCES = eINSTANCE.getdataItem_Occurrences();

		/**
		 * The meta object literal for the '<em><b>Depends on</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ITEM__DEPENDS_ON = eINSTANCE.getdataItem_Depends_on();

		/**
		 * The meta object literal for the '{@link messaging.impl.ICDImpl <em>ICD</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.impl.ICDImpl
		 * @see messaging.impl.MessagingPackageImpl#getICD()
		 * @generated
		 */
		EClass ICD = eINSTANCE.getICD();

		/**
		 * The meta object literal for the '<em><b>Messages</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ICD__MESSAGES = eINSTANCE.getICD_Messages();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ICD__NAME = eINSTANCE.getICD_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ICD__DESCRIPTION = eINSTANCE.getICD_Description();

		/**
		 * The meta object literal for the '{@link messaging.dataTypes <em>data Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.dataTypes
		 * @see messaging.impl.MessagingPackageImpl#getdataTypes()
		 * @generated
		 */
		EEnum DATA_TYPES = eINSTANCE.getdataTypes();

		/**
		 * The meta object literal for the '{@link messaging.limitsInclusion <em>limits Inclusion</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.limitsInclusion
		 * @see messaging.impl.MessagingPackageImpl#getlimitsInclusion()
		 * @generated
		 */
		EEnum LIMITS_INCLUSION = eINSTANCE.getlimitsInclusion();

		/**
		 * The meta object literal for the '{@link messaging.accesorTypes <em>accesor Types</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see messaging.accesorTypes
		 * @see messaging.impl.MessagingPackageImpl#getaccesorTypes()
		 * @generated
		 */
		EEnum ACCESOR_TYPES = eINSTANCE.getaccesorTypes();

	}

} //MessagingPackage
